package extThopt;

import java.util.*; 
import javax.swing.*;

public class CO2Emission extends ExtProcess 
{
    
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	javax.swing.JTextField duration_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField CO2_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField CH4_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField N2O_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField annualCO2_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JTextField annualC_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JTextField compRef = new javax.swing.JTextField();
	javax.swing.JComboBox JComboFuelTypes = new javax.swing.JComboBox();
    
    double K, P, A, Tex;
    int duration;
	String label2="CO2 emissions ";
	String label3="CH4 emissions ";
	String label4="N2O emissions ";
	String label5="annual CO2 emissions ";
	String label6="annual C emissions ";
    
    String[]listeConf={"Coal","Wood","Heavy fuel","light oil",
    "Natural gas","other oil products","Biogas"};
 //   "Gaz naturel","Autres produits ptroliers","Biogaz","Hydrogne"}; // l'hydrogne n'est pas encore activ
    double[]valCH4={15.,32.,3.,1.5,4.,1.5,1.5,0.};
    double[]valN2O={3.,4.,1.75,1.5,2.5,2.5,1.75,2.5};
    double[]factOxydCarb={0.98,0.98,0.99,0.99,0.995,0.99,0.995,0};
    double[]facteurEmission={26.,25.1,21.3,20.5,15.5,20.,20.5,0};

	
   
    public CO2Emission (){
        super();
		JPanel1.setLayout(null);
		JPanel1.setBounds(0,0,400,300);
		JLabel1.setText("duration (h)");
		JPanel1.add(JLabel1);
		JLabel1.setBounds(164,0,90,28);
		JPanel1.add(JComboFuelTypes);
		JComboFuelTypes.setBounds(0,0,164,28);
		JPanel1.add(duration_value);
		duration_value.setBounds(254,0,60,24);
		duration_value.setText("8000");
		JLabel2.setText(label2);
		JPanel1.add(JLabel2);
		JLabel2.setBounds(0,30,164,24);
		JPanel1.add(CO2_value);
		CO2_value.setBounds(164,30,124,24);
		CO2_value.setText("0.001");
		JLabel3.setText(label3);
		JPanel1.add(JLabel3);
		JLabel3.setBounds(0,60,164,24);
		JPanel1.add(CH4_value);
		CH4_value.setBounds(164,60,124,24);
		CH4_value.setText("1000");
		JLabel4.setText(label4);
		JPanel1.add(JLabel4);
		JLabel4.setBounds(0,90,164,24);
		JPanel1.add(N2O_value);
		N2O_value.setBounds(164,90,124,24);
		N2O_value.setText("10");
		
		JLabel5.setText(label5);
		JPanel1.add(JLabel5);
		JLabel5.setBounds(0,120,164,24);
		JPanel1.add(annualCO2_value);
		annualCO2_value.setBounds(164,120,124,24);
		annualCO2_value.setText("10");
		
		JLabel6.setText(label6);
		JPanel1.add(JLabel6);
		JLabel6.setBounds(0,150,164,24);
		JPanel1.add(annualC_value);
		annualC_value.setBounds(164,150,124,24);
		annualC_value.setText("0.8");
		JLabel7.setText("Comment");
		JPanel1.add(JLabel7);
		JLabel7.setBounds(0,180,108,24);
		JPanel1.add(compRef);
		compRef.setBounds(108,180,192,24);
		
		type=getType();
   		thermoCouplerTypes=new String[0];//no thermocoupler connected
		setupListeConf();
		
   		
 }
	void setupListeConf(){
	    for(int i=0;i<listeConf.length;i++){
	        JComboFuelTypes.addItem(listeConf[i]);
	    }
		JComboFuelTypes.setSelectedIndex(0);
	}
    
    public String getType(){
        return "CO2 emissions";
    }
	public String getClassDescription(){
	    return "CO2 emission counter\n\nauthor : R. Gicquel  june 2006\n\nRef : archive CO2Emission.zip";
	}
    
    public void init(){
        String[] args=new String[2];
        args[0]="process";//type of the element (see method getProperties(String[] args))
        args[1]=tfe.getCompName();//name of the process (see method getProperties(String[] args))
        Vector vProp=proj.getProperties(args);
        String amont=(String)vProp.elementAt(1);//gets the upstream point name
	    String aval=(String)vProp.elementAt(2);//gets the downstream point name
	    if(amont.equals(aval)){
	        String msg = "Error: the inlet and outlet points must be different for the '"+getType()+"' external process to be calculable";
	        JOptionPane.showMessageDialog(tfe, msg);  
        }
        calculateProcess();
    }
	
	public void calculateProcess(){
        String[] args=new String[2];
        
        args[0]="project";//type of the element (see method getProperties(String[] args))
        args[1]="";//name of the process (see method getProperties(String[] args))
        Vector vProp=proj.getProperties(args);
        String unitFlow=(String)vProp.elementAt(0);
        int aff_mIndex=-1;
        String[] mUnits={"-","g/s","kg/s","t/s"};
        String[] mUnit={" "," (g)"," (kg)"," (t)"};
        String[] mUnitCH4={" "," (mg/s)"," (g/s)"," (kg/s)"};
        String[] mUnit3={" "," (t)"," (kt)"," (Mt)"};
        for(int i=0;i<mUnits.length;i++){
	        if(unitFlow.equals(mUnits[i])){
	            aff_mIndex=i;
	            break;
	        }
	    }
		JLabel2.setText(label2+mUnits[aff_mIndex]);
		JLabel3.setText(label3+mUnitCH4[aff_mIndex]);
		JLabel4.setText(label4+mUnitCH4[aff_mIndex]);
		JLabel5.setText(label5+mUnit3[aff_mIndex]);
		JLabel6.setText(label6+mUnit3[aff_mIndex]);

        args[0]="process";//type of the element (see method getProperties(String[] args))
        args[1]=tfe.getCompName();//name of the process (see method getProperties(String[] args))
        vProp=proj.getProperties(args);
        Double f=(Double)vProp.elementAt(3);
        double flow=f.doubleValue();
        String amont=(String)vProp.elementAt(1);//gets the upstream point name
        getPointProperties(amont);//direct parsing of point property vector
	    duration=Util.lit_i(duration_value.getText());

	    Vector comburComp=lecorps.getGasComposition();
        double fractCO2=Util.molarComp(comburComp,"CO2");//fraction molaire de O2
	    if(fractCO2==0){
	        String msg = "Watch out: there is no CO2 in the inlet substance";
	        JOptionPane.showMessageDialog(tfe, msg);  
        }
        
	    Vector vSubst=lecorps.getSubstProperties();
        Double z=(Double)vSubst.elementAt(7);
        double gazM=z.doubleValue();//masse molaire du combustible humide
            
        int index=JComboFuelTypes.getSelectedIndex();
        double fact=facteurEmission[index];
        double CO2_massFlow=fractCO2*flow/gazM*44.*factOxydCarb[index];
	    CO2_value.setText(Util.aff_d(CO2_massFlow,4));
	    double CH4=CO2_massFlow/fact*valCH4[index];
	    CH4_value.setText(Util.aff_d(CH4,4));
	    double N2O=CO2_massFlow/fact*valN2O[index];
	    N2O_value.setText(Util.aff_d(N2O,4));
	    double totCO2=(CO2_massFlow+CH4*0.023+N2O*0.296)*duration*3.6/1000;
	    annualCO2_value.setText(Util.aff_d(totCO2,2));
	    annualC_value.setText(Util.aff_d(totCO2*12./44.,3));
    	    
	    //il faut qu'il y ait un point aval diffrent du point amont pour que la transfo soit calculable
	    //mais l'tat du point aval est le mme que celui du point amont
        tfe.setupPointAval(getProperties());
	}
    
	public void readCompParameters(String ligne_data){
	    JComboFuelTypes.setSelectedItem(Util.extr_value(ligne_data, "fuel_type"));
	    duration=Util.lit_i(Util.extr_value(ligne_data, "duration_value"));
	    duration_value.setText(Util.aff_i(duration));
		K=Util.lit_d(Util.extr_value(ligne_data, "CO2_value"));
	    CO2_value.setText(Util.aff_d(K));
		P=Util.lit_d(Util.extr_value(ligne_data, "CH4_value"));
	    CH4_value.setText(Util.aff_d(P));
		A=Util.lit_d(Util.extr_value(ligne_data, "N2O_value"));
	    N2O_value.setText(Util.aff_d(A));
		Tex=Util.lit_d(Util.extr_value(ligne_data, "annualCO2_value"));
	    annualCO2_value.setText(Util.aff_d(Tex));
	    annualC_value.setText(Util.extr_value(ligne_data, "annualC_value"));
        String valeur=Util.extr_value(ligne_data, "compRef");
        if(valeur!=null)compRef.setText(valeur);
	}
	
    public String saveCompParameters(){
	    String h="fuel_type="+JComboFuelTypes.getSelectedItem()+tab
	    +"CO2_value="+CO2_value.getText()+tab
	    +"CH4_value="+CH4_value.getText()+tab
	    +"N2O_value="+N2O_value.getText()+tab
	    +"annualCO2_value="+annualCO2_value.getText()+tab
	    +"annualC_value="+annualC_value.getText()+tab
	    +"duration_value="+duration_value.getText()+tab
	    +"compRef="+compRef.getText()+tab
	    ;
        return h;
    }


}